<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.mediator.command.ui.CommandMediatorAdminClient" %>
<%@ page import="org.wso2.carbon.mediator.service.ui.Mediator" %>
<%@ page import="org.wso2.carbon.mediator.command.CommandMediator" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.SequenceEditorHelper" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="java.rmi.RemoteException" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>


<fmt:bundle basename="org.wso2.carbon.mediator.command.ui.i18n.Resources">
<div>
<%
    Mediator mediator = SequenceEditorHelper.getEditingMediator(request, session);
    if (!(mediator instanceof CommandMediator)) {
        // todo : proper error handling
        throw new RuntimeException("Unable to edit the mediator");
    }
    CommandMediator pojoCommandMediator = (CommandMediator) mediator;
    // Set standard HTTP/1.1 no-cache headers.
    response.setHeader("Cache-Control", "no-store, max-age=0, no-cache, must-revalidate");
    // Set IE extended HTTP/1.1 no-cache headers.
    response.addHeader("Cache-Control", "post-check=0, pre-check=0");
    // Set standard HTTP/1.0 no-cache header.
    response.setHeader("Pragma", "no-cache");

    boolean classNotFound = false;
    String[] classAttrib = null;
    response.setHeader("Cache-Control", "no-cache");
    String backEndServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext context =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    CommandMediatorAdminClient client = new CommandMediatorAdminClient(cookie,
            backEndServerURL, context, request.getLocale());
    String className = request.getParameter("mediatorInput");
    pojoCommandMediator.setCommand(className);

    try {
        classAttrib = client.getClassAttributes(request.getParameter("mediatorInput"));
    } catch (RemoteException e) {
        classNotFound = true; // TODO:do nothing, set class not found exception, may be we should be more specific
    }
    if (classAttrib != null && classAttrib.length > 0 && classAttrib[0] != null && !classNotFound) {
%>
<td>
    <h3 id="propertyLabel" class="mediator"><fmt:message key="mediator.command.properties"/></h3>

    <div style="margin-top:0px;">
        <table id="commandPropTable" class="styledInner">
            <thead>
                <tr>
                    <th width="15%"><fmt:message key="mediator.command.propName"/></th>
                    <th width="15%"><fmt:message key="mediator.command.readInfo"/></th>
                    <th width="15%"><fmt:message key="mediator.command.updateInfo"/></th>
                    <th><fmt:message key="mediator.command.actions"/></th>
                </tr>
                <tbody>
                    <%
                        int index;
                        for (index = 0; index < classAttrib.length; index++) {
                    %>
                    <tr>
                        <td rowspan="2"><input type="hidden" name="propertyName<%= index%>" id="propertyName<%= index%>"
                                               value="<%= classAttrib[index]%>"/><%= classAttrib[index]%>
                        </td>
                        <td><fmt:message key="mediator.command.from"/>:
                            <select class="esb-edit small_textbox" id="propertySelectReadType<%= index%>"
                                    name="propertySelectReadType<%=index%>"
                                    onchange="javascript:reloadFromChanges(this, <%= index%>)">
                                <option value="none">- <fmt:message key="mediator.command.selectValueNone"/> -</option>
                                <option value="value" selected="true"><fmt:message
                                        key="mediator.command.selectValueValue"/></option>
                                <option value="message"><fmt:message key="mediator.command.selectValueMsg"/></option>
                                <option value="context"><fmt:message key="mediator.command.selectValueContxt"/></option>
                            </select>
                        </td>
                        <td><fmt:message key="mediator.command.to"/>:
                            <select class="esb-edit small_textbox" id="propertySelectUpdateType<%=index%>"
                                    name="propertySelectUpdateType<%=index%>"
                                    onchange="  javascript:reloadToChanges(this,<%= index%>)">
                                <option value="none" selected="true">- <fmt:message
                                        key="mediator.command.selectValueNone"/>
                                    -
                                </option>
                                <option value="message"><fmt:message key="mediator.command.selectValueMsg"/></option>
                                <option value="context"><fmt:message key="mediator.command.selectValueContxt"/></option>
                            </select>
                        </td>
                        <td><a href="#" class="icon-link" style="background-image:url(../admin/images/delete.gif);"
                               onclick="javascript:deleteRowCommand(this)"><fmt:message
                                key="mediator.command.delete"/></a>
                        </td>
                    </tr>
                    <tr>
                        <td id="newReadInfoID<%=index%>"><fmt:message key="mediator.command.selectValueValue"/>:
                            <input type="text" name="readInfo<%=index%>"/></td>
                        <td id="newUpdateInfoID<%=index%>"></td>
                    </tr>
                    <%
                        }
                    %>
                    <input type="hidden" name="propertyCount" id="propertyCount" value="<%=index%>"/>
                </tbody>
            </thead>
        </table>
            <%

                //TODO: let the error be more specific,
            } else if (classAttrib == null && !classNotFound) {  // no execute method in the class

            %>
        <td>
            <script type="text/javascript">
                CARBON.showErrorDialog('<fmt:message key="mediator.command.invalidClassMsg"/>');
            </script>
        </td>
            <%

            } else if (classNotFound) {

            %>
        <td>
            <script type="text/javascript">
                CARBON.showErrorDialog('<fmt:message key="mediator.command.classnotFoundMsg"/>');
            </script>
        </td>
            <%

                }

            %>
</td>
</div>
</fmt:bundle>