<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1" %>
<%--
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>


<%@ page import="org.wso2.carbon.mediator.service.ui.Mediator" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.SequenceEditorHelper" %>
<%@ page import="org.wso2.carbon.mediator.rule.RuleMediator" %>
<%@ page import="org.wso2.rule.description.RuleConfiguration" %>
<%@ page import="org.wso2.carbon.mediator.rule.ui.internal.RuleMediatorClientHelper" %>
<%@ page import="org.apache.axiom.om.impl.llom.util.AXIOMUtil" %>
<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="java.util.Map" %>

<%
    try {
        Mediator mediator = SequenceEditorHelper.getEditingMediator(request, session);

        if (!(mediator instanceof RuleMediator)) {
            // todo : proper error handling
            throw new RuntimeException("Unable to edit the mediator");
        }

        RuleMediator ruleMediator = (RuleMediator) mediator;

        RuleConfiguration configuration = new RuleConfiguration();
        ruleMediator.setRuleConfiguration(configuration);

        String sourceFormat = request.getParameter("mediator.rule.sourceformat");
        String ruleSession = request.getParameter("mediator.rule.rulesession");
        if (ruleSession != null && !"".equals(ruleSession)) {
            configuration.setRuleSession(ruleSession.trim());
        }
        String uri = request.getParameter("mediator.rule.provider.uri");
        String providerClass = request.getParameter("mediator.rule.provider.class");
        if (uri != null && !"".equals(uri)) {
            configuration.setProviderUri(uri.trim());
        }
        if (providerClass != null && !"".equals(providerClass)) {
            configuration.setProviderClass(providerClass.trim());
        }
        configuration.setSourceFormat(sourceFormat);

        boolean isInlined = "inline".equals(request.getParameter("mediator.rule.inline"));
        if (isInlined) {
            String policyID = SequenceEditorHelper.getEditingMediatorPosition(session) + "_rulescript";
            Map policyXMLMap = (Map) request.getSession().getAttribute("rulemediator_script_map");
            if (policyXMLMap != null) {
                String policyXML = (String) policyXMLMap.get(policyID);
                if (policyXML != null && !"".equals(policyXML)) {
                    try {
                        OMElement ele = AXIOMUtil.stringToOM(policyXML);
                        configuration.setRuleScript(ele);
                    } catch (Exception e) {
                    }
                }
            }
        } else {
            String key = request.getParameter("mediator.rule.key_hidden");
            if (key != null && !"".equals(key)) {
                configuration.setRuleScriptKey(key.trim());
            }
        }

        RuleMediatorClientHelper.setProperty(request, session, configuration,
                "addRuleExecutionSetCreationProperty", "creation");
        RuleMediatorClientHelper.setProperty(request, session, configuration,
                "addRuleExecutionSetRegistrationProperty", "registration");
        RuleMediatorClientHelper.setProperty(request, session, configuration,
                "addRuleExecutionSetDeregistrationProperty", "deregistration");
        RuleMediatorClientHelper.setProperty(request, session, configuration,
                "addRuleSessionProperty", "rulesession");
        RuleMediatorClientHelper.setProperty(request, session, configuration,
                "addRuleExecutionSetProviderProperty", "provider");
        RuleMediatorClientHelper.setInputOutput(request, session,
                configuration, "addInput", "input");
        RuleMediatorClientHelper.setInputOutput(request, session,
                configuration, "addOutput", "output");
%>


<%
} catch (Exception e) {

%>
<script type="text/javascript">
    jQuery(document).ready(function() {
        CARBON.showErrorDialog("An error has been occurred !. Error Message : " + '<%=e.getMessage()%>');
    });
</script>
<%
        return;
    }
%>
