<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="org.apache.axiom.om.OMFactory" %>
<%@ page import="org.apache.axiom.om.impl.builder.StAXOMBuilder" %>
<%@ page import="org.wso2.carbon.mediator.service.builtin.SequenceMediator" %>
<%@ page import="org.wso2.carbon.sequences.ui.DelegatingSequenceAdminClient" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="java.io.ByteArrayInputStream" %>
<%@ page import="java.util.ResourceBundle" %>

<%
    ResourceBundle bundle = ResourceBundle.getBundle("org.wso2.carbon.sequences.ui.i18n.Resources",
            request.getLocale());

    DelegatingSequenceAdminClient sequenceAdminClient
            = new DelegatingSequenceAdminClient();
    SequenceMediator seq = null;
    String action = request.getParameter("action");
    String header = "";
    String seqXML = (String)session.getAttribute("seqXML");
    String key = request.getParameter("key");

    String forwardTo = "";
    if (request.getParameter("cancelled") != null && "true".equals(request.getParameter("cancelled"))) {
        forwardTo = "list_sequences.jsp";
        // removes common attributes
        removeCommonSessionAttributes(session);
    } else {
        if (seqXML != null && !"".equals(seqXML)) {            
            // return path from save_sequence.jsp
            header = (String)session.getAttribute("header");
            forwardTo = "list_sequences.jsp";
            seqXML = seqXML.replaceAll("&gt", ">");
            seqXML = seqXML.replaceAll("&lt", "<");

            try {
                OMElement elem = new StAXOMBuilder(new ByteArrayInputStream(seqXML.getBytes())).getDocumentElement();
                String name = (String)session.getAttribute("registrySequenceName");
                OMFactory fac = elem.getOMFactory();
                if (name != null) {
                    elem.addAttribute("name", name, null);
                }
                seq = new SequenceMediator();
                seq.build(elem);
                key = (String) session.getAttribute("sequenceRegistryKey");
                if (key != null) {
                    sequenceAdminClient.updateDynamicSequence(getServletConfig(), session, key, seq);
                }
            } catch (Exception e) {
                removeCommonSessionAttributes(session);
                CarbonUIMessage.sendCarbonUIMessage(bundle.getString(bundle.getString(
                        "unable.to.build.sequence.object.from.the.given.sequence.information")),
                        CarbonUIMessage.ERROR, request);
                return;
            }
            // removes the session attribute, seqXML
            session.removeAttribute("seqXML");
            // removes common session attributes
            removeCommonSessionAttributes(session);
        } else if (action != null && action.equals("edit") && key != null){
            // sets the anonOriginator to anonSequenceHandler.jsp. This will be the page to which result should be returned
            session.setAttribute("sequenceAnonOriginator", "registry_sequence.jsp");
            // send path to design_sequence.jsp
            header = request.getParameter("header");
            // exports the header in to the session
            session.setAttribute("header", header);
            forwardTo = "./design_sequence.jsp";
            // sets sequnce (i.e. in/out/fault) as a session attribute
            session.setAttribute("sequenceRegistryKey", key);
            try {
                OMElement elem = sequenceAdminClient.getDynamicSequence(getServletConfig(),
                        session, key);
                OMFactory fac = elem.getOMFactory();
                seq = new SequenceMediator();
                seq.build(elem);
                session.setAttribute("registrySequenceName", seq.getName());
            } catch (Exception e) {
                session.setAttribute("dynamic_edit","fail");
                forwardTo = "./list_sequences.jsp";
            }
            session.setAttribute("editingSequence", seq);
            session.setAttribute("editingSequenceAction", "anonify");
            session.removeAttribute("mediator.position");
        }
    }
%>
<%!
    void removeCommonSessionAttributes(HttpSession session) {
        session.removeAttribute("seqXML");
        session.removeAttribute("sequenceAnonOriginator");
        session.removeAttribute("header");
        session.removeAttribute("editingSequence");
        session.removeAttribute("editingSequenceAction");
        session.removeAttribute("mediator.position");
    }


%>

<script type="text/javascript">
    if (window.location.href.indexOf('originator') != -1) {
        window.location.href = "<%=forwardTo%>";
    } else {
        window.location.href = "<%=forwardTo%>";
    }
</script>

<%
    if ("fail".equals(session.getAttribute("dynamic_edit"))) {
        removeCommonSessionAttributes(session);
    }
%>